'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lezer = require('lezer');
var language = require('@codemirror/language');
var highlight = require('@codemirror/highlight');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lezer.Parser.deserialize({
  version: 13,
  states: "!|QYQPOOOeQPO'#CiO|QPO'#CfOOQO'#Cm'#CmQYQPOOOYQPO,58{OYQPO,58{OYQPO,58{OYQPO,59QOOQO-E6g-E6gOOQO1G.g1G.gO!jQPO1G.gO!qQPO1G.gO!xQPO1G.lOOQO7+$W7+$W",
  stateData: "#W~O`OSPOS~ORROSROZQO~OUTOVUOWVOR]XS]XZ]X^]X~O[WO~OUTORTiSTiWTiZTi^TiXTi~OVTi~P!ROVUO~P!ROUTOVUOWVOX^O~O",
  goto: "!RbPPPPPcPPPPcPPkPPPq]ROSTUVWQSORXSSPOSQYTQZUQ[VR]W",
  nodeNames: "⚠ LineComment Program Number String BinaryExpression CompareOp LogicAnd LogicOr ) Function Keyword (",
  maxTerm: 17,
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "%k~RcXY!^YZ!^]^!^pq!^qr!ors!zxy#iyz#n!Q![#s!]!^#{!^!_$W!_!`!o!`!a$W!c!d$`!q!r$q#T#U$|#V#W%[#h#i%b#m#n%[~!cS`~XY!^YZ!^]^!^pq!^~!rP!_!`!u~!zOU~~!}TOr!zrs#^s#O!z#O#P#c#P~!z~#cOS~~#fPO~!z~#nO[~~#sOX~~#xPR~!Q![#s~$QQP~OY#{Z~#{~$]PU~!_!`!u~$cP!p!q$f~$iP!f!g$l~$qOV~~$tP!t!u$w~$|OW~~%PQ![!]%V#i#j%[~%[OZ~~%_P![!]%V~%eQ![!]%V#T#U%[",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

// import { EditorView } from "@codemirror/view";
const papershiveLanguage = language.LezerLanguage.define({
    parser: parser.configure({
        props: [
            language.foldNodeProp.add({
                BinaryExpression: language.foldInside,
                Function: language.foldInside
            }),
            highlight.styleTags({
                String: highlight.tags.string,
                LineComment: highlight.tags.lineComment,
                "( )": highlight.tags.paren,
                LogicAnd: highlight.tags.operatorKeyword,
                LogicOr: highlight.tags.operatorKeyword,
                CompareOp: highlight.tags.compareOperator,
                Keyword: highlight.tags.keyword,
                Number: highlight.tags.number
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
const papershiveCompletion = papershiveLanguage.data.of({
    autocomplete: autocomplete.completeFromList([
        {
            label: "au:",
            type: "function",
            detail: "Authors",
            apply: 'au:("")'
        },
        { label: "a:", type: "function", detail: "Abstracts", apply: 'a:("")' },
        { label: "t:", type: "function", detail: "Titless", apply: 't:("")' },
        {
            label: "ta:",
            type: "function",
            detail: "Titles and Abstracts",
            apply: 'ta:("")'
        },
        { label: "c:", type: "function", detail: "Citations", apply: 'c:("")' },
        { label: "y:<", type: "function", detail: "Published before year" },
        { label: "y:>", type: "function", detail: "Published after year" },
        {
            label: "y:<=",
            type: "function",
            detail: "Published before and including year"
        },
        {
            label: "y:>=",
            type: "function",
            detail: "Published after and including year"
        },
        {
            label: "AND",
            type: "logicOperator"
        },
        { label: "OR", type: "logicOperator" }
    ])
});
function papershive() {
    return new language.LanguageSupport(papershiveLanguage, [papershiveCompletion]);
}

exports.papershive = papershive;
exports.papershiveCompletion = papershiveCompletion;
exports.papershiveLanguage = papershiveLanguage;
